import _extends from "babel-runtime/helpers/extends";
import _classCallCheck from "babel-runtime/helpers/classCallCheck";
import _createClass from "babel-runtime/helpers/createClass";
import _possibleConstructorReturn from "babel-runtime/helpers/possibleConstructorReturn";
import _inherits from "babel-runtime/helpers/inherits";
import React, { Component } from "react";
import { Layout, Breadcrumb, Icon, Dropdown, Menu, Avatar } from "antd";
import p from "solomon-class-prefix";
import "./style.less";

var Header = Layout.Header;


var CLS_PREFIX = "solomon-top-header";

var addPrefix = p(CLS_PREFIX);

var HeaderComponent = function (_Component) {
  _inherits(HeaderComponent, _Component);

  function HeaderComponent() {
    _classCallCheck(this, HeaderComponent);

    return _possibleConstructorReturn(this, (HeaderComponent.__proto__ || Object.getPrototypeOf(HeaderComponent)).apply(this, arguments));
  }

  _createClass(HeaderComponent, [{
    key: "render",
    value: function render() {
      // const { leftContent, middleContent, rightContent, home, logo, logoTitle } = this.props;
      var _props = this.props,
          className = _props.className,
          _props$theme = _props.theme,
          theme = _props$theme === undefined ? "light" : _props$theme,
          _props$showMenu = _props.showMenu,
          showMenu = _props$showMenu === undefined ? false : _props$showMenu,
          _props$menuData = _props.menuData,
          menuData = _props$menuData === undefined ? [] : _props$menuData,
          _props$showBreadcrumb = _props.showBreadcrumb,
          showBreadcrumb = _props$showBreadcrumb === undefined ? true : _props$showBreadcrumb,
          logoRender = _props.logoRender,
          collapsed = _props.collapsed,
          username = _props.username,
          avatar = _props.avatar,
          actionRender = _props.actionRender,
          onCollapse = _props.onCollapse,
          onLogout = _props.onLogout,
          _props$menuOptions = _props.menuOptions,
          menuOptions = _props$menuOptions === undefined ? {} : _props$menuOptions,
          _props$breadcrumbData = _props.breadcrumbData,
          breadcrumbData = _props$breadcrumbData === undefined ? [] : _props$breadcrumbData,
          localeRender = _props.localeRender,
          _props$fixed = _props.fixed,
          fixed = _props$fixed === undefined ? false : _props$fixed;
      var _menuOptions$width = menuOptions.width,
          width = _menuOptions$width === undefined ? 256 : _menuOptions$width,
          _menuOptions$miniWidt = menuOptions.miniWidth,
          miniWidth = _menuOptions$miniWidt === undefined ? 80 : _menuOptions$miniWidt;

      // const { selectedKeys } = menuOptions;

      var menu = React.createElement(
        Menu,
        { onClick: onLogout },
        React.createElement(
          Menu.Item,
          { key: "logout" },
          React.createElement(Icon, { type: "logout" }),
          "\u9000\u51FA\u767B\u5F55"
        )
      );

      var collapseRender = function collapseRender() {
        if (collapsed === undefined || showMenu === true) {
          return null;
        }
        return React.createElement(Icon, {
          className: addPrefix("trigger"),
          type: collapsed ? "menu-unfold" : "menu-fold",
          onClick: onCollapse && onCollapse
        });
      };

      var localMenuRender = function localMenuRender() {
        if (!showMenu || menuData.length <= 0) {
          return null;
        }
        var newMenuOptions = _extends({}, menuOptions, {
          selectedKeys: [menuOptions.selectedkey],
          mode: "horizontal"
        });
        // 考虑到设计师的设计跟antd不符，这里采用手动覆盖样式的方式，如果以后出现无法满足需求的情况，可以考虑吧theme传递到menu中去
        delete newMenuOptions.theme;
        delete newMenuOptions.selectedkey;

        return React.createElement(
          "div",
          { className: addPrefix("menubox") },
          React.createElement(
            Menu,
            newMenuOptions,
            menuData.map(function (item) {
              return React.createElement(
                Menu.Item,
                { key: item.key, link: item.link },
                item.title
              );
            })
          )
        );
      };

      var userRender = React.createElement(
        "div",
        { className: addPrefix("userbox") },
        React.createElement(
          Dropdown,
          { overlay: menu },
          React.createElement(
            "span",
            { className: addPrefix("userinfo") },
            React.createElement(Avatar, {
              style: { backgroundColor: "#87d068" },
              size: "small"
              // className={styles.img}
              , icon: "user"
              // src={avatar}
            }),
            React.createElement(
              "span",
              { className: addPrefix("userinfo-name") },
              username
            )
          )
        )
      );

      // 暂时不支持单击跳环
      var breadcrumbRender = function breadcrumbRender() {
        var selectedkey = menuOptions.selectedkey;

        if (!showBreadcrumb || !selectedkey) {
          return null;
        }
        if (breadcrumbData.length <= 0) {
          return null;
        }
        return React.createElement(
          "div",
          { className: addPrefix("breadcrumb") },
          React.createElement(
            Breadcrumb,
            null,
            breadcrumbData.map(function (item) {
              return React.createElement(
                Breadcrumb.Item,
                { key: item.key },
                item.title
              );
            })
          )
        );
      };

      var localLogoRender = function localLogoRender() {
        if (collapsed !== undefined || typeof logoRender !== "function") {
          return null;
        }
        return React.createElement(
          "div",
          { className: addPrefix("logoBox") },
          logoRender()
        );
      };

      var headerClassNames = [];
      headerClassNames.push(addPrefix("header"));
      if (showMenu) {
        headerClassNames.push(addPrefix("horizontal"));
      }
      if (className) {
        headerClassNames.push(className);
      }
      if (theme === "dark") {
        headerClassNames.push(addPrefix("dark"));
      }
      var rootClassName = [addPrefix("wrap")];
      if (fixed) {
        rootClassName.push(addPrefix("fixed"));
      }
      var rootStyles = {
        padding: "0px",
        width: "calc(100% - " + width + "px)",
        zIndex: 2
      };
      if (collapsed) {
        rootStyles.width = "calc(100% - " + miniWidth + "px)";
      }
      return React.createElement(
        "div",
        {
          className: rootClassName.join(" "),
          style: fixed ? rootStyles : null
        },
        React.createElement(
          Header,
          { className: headerClassNames.join(" ") },
          React.createElement(
            "div",
            { className: addPrefix("left") },
            localLogoRender(),
            collapseRender(),
            localMenuRender()
          ),
          React.createElement(
            "div",
            { className: addPrefix("right") },
            actionRender ? actionRender() : null,
            username ? userRender : null,
            typeof localeRender === "function" ? localeRender() : null
          )
        ),
        breadcrumbRender()
      );
    }
  }]);

  return HeaderComponent;
}(Component);

// export { getActiveMenu };

export default HeaderComponent;