"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _antd = require("antd");

var _solomonClassPrefix = require("solomon-class-prefix");

var _solomonClassPrefix2 = _interopRequireDefault(_solomonClassPrefix);

require("./style.less");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var Header = _antd.Layout.Header;


var CLS_PREFIX = "solomon-top-header";

var addPrefix = (0, _solomonClassPrefix2["default"])(CLS_PREFIX);

var HeaderComponent = function (_Component) {
  (0, _inherits3["default"])(HeaderComponent, _Component);

  function HeaderComponent() {
    (0, _classCallCheck3["default"])(this, HeaderComponent);
    return (0, _possibleConstructorReturn3["default"])(this, (HeaderComponent.__proto__ || Object.getPrototypeOf(HeaderComponent)).apply(this, arguments));
  }

  (0, _createClass3["default"])(HeaderComponent, [{
    key: "render",
    value: function render() {
      // const { leftContent, middleContent, rightContent, home, logo, logoTitle } = this.props;
      var _props = this.props,
          className = _props.className,
          _props$theme = _props.theme,
          theme = _props$theme === undefined ? "light" : _props$theme,
          _props$showMenu = _props.showMenu,
          showMenu = _props$showMenu === undefined ? false : _props$showMenu,
          _props$menuData = _props.menuData,
          menuData = _props$menuData === undefined ? [] : _props$menuData,
          _props$showBreadcrumb = _props.showBreadcrumb,
          showBreadcrumb = _props$showBreadcrumb === undefined ? true : _props$showBreadcrumb,
          logoRender = _props.logoRender,
          collapsed = _props.collapsed,
          username = _props.username,
          avatar = _props.avatar,
          actionRender = _props.actionRender,
          onCollapse = _props.onCollapse,
          onLogout = _props.onLogout,
          _props$menuOptions = _props.menuOptions,
          menuOptions = _props$menuOptions === undefined ? {} : _props$menuOptions,
          _props$breadcrumbData = _props.breadcrumbData,
          breadcrumbData = _props$breadcrumbData === undefined ? [] : _props$breadcrumbData,
          localeRender = _props.localeRender,
          _props$fixed = _props.fixed,
          fixed = _props$fixed === undefined ? false : _props$fixed;
      var _menuOptions$width = menuOptions.width,
          width = _menuOptions$width === undefined ? 256 : _menuOptions$width,
          _menuOptions$miniWidt = menuOptions.miniWidth,
          miniWidth = _menuOptions$miniWidt === undefined ? 80 : _menuOptions$miniWidt;

      // const { selectedKeys } = menuOptions;

      var menu = _react2["default"].createElement(
        _antd.Menu,
        { onClick: onLogout },
        _react2["default"].createElement(
          _antd.Menu.Item,
          { key: "logout" },
          _react2["default"].createElement(_antd.Icon, { type: "logout" }),
          "\u9000\u51FA\u767B\u5F55"
        )
      );

      var collapseRender = function collapseRender() {
        if (collapsed === undefined || showMenu === true) {
          return null;
        }
        return _react2["default"].createElement(_antd.Icon, {
          className: addPrefix("trigger"),
          type: collapsed ? "menu-unfold" : "menu-fold",
          onClick: onCollapse && onCollapse
        });
      };

      var localMenuRender = function localMenuRender() {
        if (!showMenu || menuData.length <= 0) {
          return null;
        }
        var newMenuOptions = (0, _extends3["default"])({}, menuOptions, {
          selectedKeys: [menuOptions.selectedkey],
          mode: "horizontal"
        });
        // 考虑到设计师的设计跟antd不符，这里采用手动覆盖样式的方式，如果以后出现无法满足需求的情况，可以考虑吧theme传递到menu中去
        delete newMenuOptions.theme;
        delete newMenuOptions.selectedkey;

        return _react2["default"].createElement(
          "div",
          { className: addPrefix("menubox") },
          _react2["default"].createElement(
            _antd.Menu,
            newMenuOptions,
            menuData.map(function (item) {
              return _react2["default"].createElement(
                _antd.Menu.Item,
                { key: item.key, link: item.link },
                item.title
              );
            })
          )
        );
      };

      var userRender = _react2["default"].createElement(
        "div",
        { className: addPrefix("userbox") },
        _react2["default"].createElement(
          _antd.Dropdown,
          { overlay: menu },
          _react2["default"].createElement(
            "span",
            { className: addPrefix("userinfo") },
            _react2["default"].createElement(_antd.Avatar, {
              style: { backgroundColor: "#87d068" },
              size: "small"
              // className={styles.img}
              , icon: "user"
              // src={avatar}
            }),
            _react2["default"].createElement(
              "span",
              { className: addPrefix("userinfo-name") },
              username
            )
          )
        )
      );

      // 暂时不支持单击跳环
      var breadcrumbRender = function breadcrumbRender() {
        var selectedkey = menuOptions.selectedkey;

        if (!showBreadcrumb || !selectedkey) {
          return null;
        }
        if (breadcrumbData.length <= 0) {
          return null;
        }
        return _react2["default"].createElement(
          "div",
          { className: addPrefix("breadcrumb") },
          _react2["default"].createElement(
            _antd.Breadcrumb,
            null,
            breadcrumbData.map(function (item) {
              return _react2["default"].createElement(
                _antd.Breadcrumb.Item,
                { key: item.key },
                item.title
              );
            })
          )
        );
      };

      var localLogoRender = function localLogoRender() {
        if (collapsed !== undefined || typeof logoRender !== "function") {
          return null;
        }
        return _react2["default"].createElement(
          "div",
          { className: addPrefix("logoBox") },
          logoRender()
        );
      };

      var headerClassNames = [];
      headerClassNames.push(addPrefix("header"));
      if (showMenu) {
        headerClassNames.push(addPrefix("horizontal"));
      }
      if (className) {
        headerClassNames.push(className);
      }
      if (theme === "dark") {
        headerClassNames.push(addPrefix("dark"));
      }
      var rootClassName = [addPrefix("wrap")];
      if (fixed) {
        rootClassName.push(addPrefix("fixed"));
      }
      var rootStyles = {
        padding: "0px",
        width: "calc(100% - " + width + "px)",
        zIndex: 2
      };
      if (collapsed) {
        rootStyles.width = "calc(100% - " + miniWidth + "px)";
      }
      return _react2["default"].createElement(
        "div",
        {
          className: rootClassName.join(" "),
          style: fixed ? rootStyles : null
        },
        _react2["default"].createElement(
          Header,
          { className: headerClassNames.join(" ") },
          _react2["default"].createElement(
            "div",
            { className: addPrefix("left") },
            localLogoRender(),
            collapseRender(),
            localMenuRender()
          ),
          _react2["default"].createElement(
            "div",
            { className: addPrefix("right") },
            actionRender ? actionRender() : null,
            username ? userRender : null,
            typeof localeRender === "function" ? localeRender() : null
          )
        ),
        breadcrumbRender()
      );
    }
  }]);
  return HeaderComponent;
}(_react.Component);

// export { getActiveMenu };

exports["default"] = HeaderComponent;
module.exports = exports['default'];